arm64: synchronous abort booting linux

Bug #1476882 reported by dann frazier
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
grub2 (Ubuntu)
High
dann frazier
Trusty
High
Unassigned
Vivid
High
Unassigned
Wily
High
dann frazier

Bug Description

[Impact]
On some UEFI firmware implementations for ARM64 (debug versions of Tianocore, as well as builds from AMI), GRUB will fail with Synchronous Aborts when starting the Linux kernel. It is therefore not possible to install or run Ubuntu on these systems.

[Test Case]
Download the Ubuntu debian-installer netboot.tar.gz and boot and direct a system to boot from the grubnet image within. (Currently only 15.10 and newer have this tarball, though it should eventually appear in 14.04 as an SRU).

[Regression Risk]
The proposed patch touches only arm64 code, which limits the impact to just arm64 systems. There are few ARM64/UEFI systems on the market/supported by Ubuntu, so the risk is quite contained.

Revision history for this message
dann frazier (dannf) wrote :

I've pushed a proposed fix - a clean cherry pick from upstream - here:

The following changes since commit 38a01d84bb5171a1af7a87bcb45d89febd74907f:

  releasing package grub2 version 2.02~beta2-26 (2015-06-14 10:05:04 +0100)

are available in the git repository at:

  https://git.launchpad.net/~dannf/grub2 origin/people/dannf/arm64-correct-dev-path-length

for you to fetch changes up to 8b5d5f706e27bcb81a7fefa0a03fd21741228195:

  merge patched-origin/people/dannf/arm64-correct-dev-path-length into origin/people/dannf/arm64-correct-dev-path-length (2015-07-21 19:27:30 -0600)

----------------------------------------------------------------
Leif Lindholm (1):
      arm64: set correct length of device path end entry

dann frazier (1):
      merge patched-origin/people/dannf/arm64-correct-dev-path-length into origin/people/dannf/arm64-correct-dev-path-length

 debian/.git-dpm | 4 ++--
 debian/patches/arm64-set-correct-length-of-device-path-end-entry.patch | 29 +++++++++++++++++++++++++++++
 debian/patches/series | 1 +
 grub-core/loader/arm64/linux.c | 2 +-
 4 files changed, 33 insertions(+), 3 deletions(-)
 create mode 100644 debian/patches/arm64-set-correct-length-of-device-path-end-entry.patch

dann frazier (dannf)
Changed in grub2 (Ubuntu):
assignee: nobody → dann frazier (dannf)
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package grub2 - 2.02~beta2-26ubuntu5

---------------
grub2 (2.02~beta2-26ubuntu5) wily; urgency=medium

  * No-change rebuild to force the arm64 UEFI bits to be signed by LP.

 -- Adam Conrad <email address hidden> Wed, 22 Jul 2015 19:41:58 -0600

Changed in grub2 (Ubuntu):
status: Confirmed → Fix Released
dann frazier (dannf)
Changed in grub2 (Ubuntu Trusty):
status: New → Confirmed
Changed in grub2 (Ubuntu Vivid):
status: New → Confirmed
Steve Langasek (vorlon)
description: updated
Revision history for this message
Steve Langasek (vorlon) wrote : Please test proposed package

Hello dann, or anyone else affected,

Accepted grub2 into trusty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/grub2/2.02~beta2-9ubuntu1.5 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in grub2 (Ubuntu Trusty):
status: Confirmed → Fix Committed
tags: added: verification-needed
Revision history for this message
Steve Langasek (vorlon) wrote :

Hello dann, or anyone else affected,

Accepted grub2 into vivid-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/grub2/2.02~beta2-22ubuntu1.3 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in grub2 (Ubuntu Vivid):
status: Confirmed → Fix Committed
Revision history for this message
Chris J Arges (arges) wrote :

Hello dann, or anyone else affected,

Accepted grub2-signed into trusty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/grub2-signed/1.34.6 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Revision history for this message
Chris J Arges (arges) wrote :

Hello dann, or anyone else affected,

Accepted grub2-signed into vivid-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/grub2-signed/1.46.3 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Revision history for this message
Sean Feole (sfeole) wrote :

ii grub-common 2.02~beta2-9ubuntu1.5 arm64 GRand Unified Bootloader (common files)
ii grub-efi-arm64 2.02~beta2-9ubuntu1.5 arm64 GRand Unified Bootloader, version 2 (ARM64 UEFI version)
ii grub-efi-arm64-bin 2.02~beta2-9ubuntu1.5 arm64 GRand Unified Bootloader, version 2 (ARM64 UEFI binaries)
ii grub-legacy-ec2 0.7.5-0ubuntu1.15 all Handles update-grub for ec2 instances
ii grub2-common 2.02~beta2-9ubuntu1.5 arm64 GRand Unified Bootloader (common files for version 2)

I was able to pull down the following grub debs from trusty-proposed and test on some of the affected hardware. All of the tests passed, and I was able to boot from disk, using, \efi\ubuntu\grubaa64.efi

$ uname -a
Linux cvm8 3.18.0-14.19-generic #15-Ubuntu SMP Fri Jul 31 16:08:20 UTC 2015 aarch64 aarch64 aarch64 GNU/Linux

$ lsb_release -a
No LSB modules are available.
Distributor ID: Ubuntu
Description: Ubuntu 14.04.3 LTS
Release: 14.04
Codename: trusty

dann frazier (dannf)
Changed in grub2 (Ubuntu Trusty):
importance: Undecided → High
Changed in grub2 (Ubuntu Vivid):
importance: Undecided → High
Sean Feole (sfeole)
tags: added: verification-done
removed: verification-needed
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package grub2 - 2.02~beta2-9ubuntu1.5

---------------
grub2 (2.02~beta2-9ubuntu1.5) trusty; urgency=medium

  * d/p/arm64-set-correct-length-of-device-path-end-entry.patch: Fixes
    booting arm64 kernels on certain UEFI implementations. (LP: #1476882)
  * progress: avoid NULL dereference for net files. (LP: #1459872)
  * arm64/setjmp: Add missing license macro. (LP: #1459871)
  * Cherry-pick patch to add SAS disks to the device list from the ofdisk
    module. (LP: #1517586)
  * Cherry-pick patch to open Simple Network Protocol exclusively.
    (LP: #1508893)

 -- dann frazier <email address hidden> Wed, 25 Nov 2015 13:13:35 -0700

Changed in grub2 (Ubuntu Trusty):
status: Fix Committed → Fix Released
Revision history for this message
Steve Langasek (vorlon) wrote : Update Released

The verification of the Stable Release Update for grub2 has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Revision history for this message
Chris J Arges (arges) wrote : Please test proposed package

Hello dann, or anyone else affected,

Accepted grub2 into vivid-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/grub2/2.02~beta2-22ubuntu1.5 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: removed: verification-done
tags: added: verification-needed
Revision history for this message
Chris J Arges (arges) wrote :

Hello dann, or anyone else affected,

Accepted grub2-signed into vivid-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/grub2-signed/1.46.5 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

dann frazier (dannf)
tags: added: verification-done-vivid
removed: verification-needed
dann frazier (dannf)
tags: added: verification-done verification-done-wily
dann frazier (dannf)
tags: removed: verification-done-wily
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package grub2 - 2.02~beta2-22ubuntu1.5

---------------
grub2 (2.02~beta2-22ubuntu1.5) vivid; urgency=medium

  * Merge in changes from 2.02~beta2-22ubuntu1.3:
    - d/p/arm64-set-correct-length-of-device-path-end-entry.patch: Fixes
      booting arm64 kernels on certain UEFI implementations. (LP: #1476882)
    - progress: avoid NULL dereference for net files. (LP: #1459872)
    - arm64/setjmp: Add missing license macro. (LP: #1459871)
    - Cherry-pick patch to add SAS disks to the device list from the ofdisk
      module. (LP: #1517586)
    - Cherry-pick patch to open Simple Network Protocol exclusively.
      (LP: #1508893)
  * Cherry-picks to better handle TFTP timeouts on some arches: (LP: #1521612)
    - (7b386b7) efidisk: move device path helpers in core for efinet
    - (c52ae40) efinet: skip virtual IP devices when enumerating cards
    - (f348aee) efinet: enable hardware filters when opening interface
  * Update quick boot logic to handle abstractions for which there is no
    write support. (LP: #1274320)

 -- dann frazier <email address hidden> Wed, 16 Dec 2015 13:31:15 -0700

Changed in grub2 (Ubuntu Vivid):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers